CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

  serXmit   = 30                      ' Serial Transmit
  serRecv   = 31                      ' Serial Receive
  speed     = 57600

OBJ
  debug:    "MultiCogSerialDebug"
  mp:       "MethodPointer"
  batch:    "batch"

VAR
  long fnctPtr1[2]
  long fnctPtr2[2]
  long fnctPtr3[2]

DAT
  debugSemID byte 0

PUB Main | retStat
  'wait for me to connect the serial terminal
  waitcnt(cnt + clkfreq*5)

  debugSemID := locknew 'used with MultiCogSerialDebug

  debug.start(serRecv,serXmit,0,speed,debugSemID)
  debug.cprintf(String("main v2.3\r"), 0, false)
  debug.cprintf(String("ticks = %x\r"), clkfreq, false)

  ' Initialize the method pointer routines
  mp.Initialize
  batch.Start
  if mp.SetMethodPtrEx(@fnctPtr1)
    tstJob(0)
  if mp.SetMethodPtrEx(@fnctPtr2)
    tstJob2(0)
  if mp.SetMethodPtrEx(@fnctPtr3)
    tstJob3(0)

  retStat := batch.addJob(@fnctPtr1, $DEADBEEF, clkfreq*100, true)
  debug.cprintf(String("should fail to add repeating job to batch queue. jobNum %x\r"), retStat, false)

  retStat := batch.addJob(@fnctPtr1, $DEADBEEF, clkfreq*10, true)
  debug.cprintf(String("add repeating job to batch queue. jobNum %x\r"), retStat, false)

  retStat := batch.addJob(@fnctPtr3, $87654321, clkfreq*12, false)
  debug.cprintf(String("add non-repeating job to batch queue. jobNum %x\r"), retStat, false)

  retStat := batch.addJob(@fnctPtr1, $BA11DEAF, clkfreq*5, true)
  debug.cprintf(String("add repeating job to batch queue. jobNum %x\r"), retStat, false)

  retStat := batch.addJob(@fnctPtr2, $12345678, clkfreq*17, true)
  debug.cprintf(String("add repeating job to batch queue. jobNum %x\r"), retStat, false)

  retStat := batch.addJob(@fnctPtr2, 5, clkfreq*5, true)
  debug.cprintf(String("add repeating job to batch queue. jobNum %x\r"), retStat, false)
  retStat := batch.addJob(@fnctPtr2, 6, clkfreq*6, true)
  debug.cprintf(String("add repeating job to batch queue. jobNum %x\r"), retStat, false)
  retStat := batch.addJob(@fnctPtr2, 7, clkfreq*7, true)
  debug.cprintf(String("add repeating job to batch queue. jobNum %x\r"), retStat, false)
  retStat := batch.addJob(@fnctPtr2, 8, clkfreq*8, true)
  debug.cprintf(String("add repeating job to batch queue. jobNum %x\r"), retStat, false)
  retStat := batch.addJob(@fnctPtr2, 9, clkfreq*9, true)
  debug.cprintf(String("add repeating job to batch queue. jobNum %x\r"), retStat, false)

  waitcnt(cnt + clkfreq*18)
  retStat := batch.cancelJob(3)
  debug.cprintf(String("cancel jobNum 3 - retstat %x\r"), retStat, false)

  repeat

PUB tstJob(arg1)
  debug.cprintf(String("tstJob - arg1 = %x\r"), arg1, false)

PUB tstJob2(arg1)
  debug.cprintf(String("tstJob2 - arg1 = %x\r"), arg1, false)

PUB tstJob3(arg1) | retStat
  debug.cprintf(String("tstJob3 - arg1 = %x\r"), arg1, false)
  retStat := batch.addJob(@fnctPtr3, $87654321, clkfreq*12, false)
  debug.cprintf(String("add non-repeating job to batch queue. jobNum %x\r"), retStat, false)

